"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class CancerParticipant(ProtocolElement):
    """
    This defines a Cancer Participant (demographics and sample
    information)
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "cancerDemographics",
        "cancerSamples",
        "matchedSamples",
        "versionControl",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_3_0_0 import reports as reports_3_0_0

        return {
            "cancerDemographics": reports_3_0_0.CancerDemographics,
            "cancerSamples": reports_3_0_0.CancerSample,
            "matchedSamples": reports_3_0_0.MatchedSamples,
            "versionControl": reports_3_0_0.VersionControl,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_3_0_0 import reports as reports_3_0_0

        return {
            "org.gel.models.report.avro.CancerDemographics": reports_3_0_0.CancerDemographics,
            "org.gel.models.report.avro.CancerSample": reports_3_0_0.CancerSample,
            "org.gel.models.report.avro.MatchedSamples": reports_3_0_0.MatchedSamples,
            "org.gel.models.report.avro.VersionControl": reports_3_0_0.VersionControl,
            "org.gel.models.report.avro.CancerParticipant": reports_3_0_0.CancerParticipant,
        }

    __slots__ = [
        "cancerDemographics",
        "cancerSamples",
        "matchedSamples",
        "versionControl",
    ]

    def __init__(
        self,
        cancerDemographics,
        cancerSamples,
        matchedSamples,
        versionControl,
        validate=None,
        **kwargs
    ):
        """Initialise the reports_3_0_0.CancerParticipant model.

        :param cancerDemographics:
            This contains all the demographic information
        :type cancerDemographics: CancerDemographics
        :param cancerSamples:
            List of samples (normal and tumor sample)
        :type cancerSamples: list[CancerSample]
        :param matchedSamples:
            List of Matched Samples (this is, all the normal - tumor pairs should
            be analyzed)
        :type matchedSamples: list[MatchedSamples]
        :param versionControl:
            Model version number
        :type versionControl: VersionControl
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "3.0.0"
